BASE_DIR := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

# USER INPUT
INSTALL_DIR ?= ${BASE_DIR}applications/build
DEBUG ?= 0
MPI ?=
DMR ?=
MKL ?=
XBRAID ?=
P4EST ?=
DYN_XBRAID ?=
DYN_P4ST ?=
DYN_PETSC ?=
LIBPFASST ?=
DATA_REDIST ?=
TIMESTAMPS ?=

MPI_OPTION=
DMR_OPTION=
MKL_OPTION=
XBRAID_OPTION=
P4EST_OPTION=
DYN_XBRAID_OPTION=
DYN_P4EST_OPTION=
DYN_PETSC_OPTION=
LIBPFASST_OPTION=
DATA_REDIST_OPTION=
TIMESTAMPS_OPTION=

ifdef MPI
	MPI_OPTION="OMPI=${MPI}"
endif

ifdef DMR
	DMR_OPTION="DMR=${DMR}"
endif

ifdef MKL
	MKL_OPTION="MKL=${MKL}"
endif

ifdef XBRAID
	XBRAID_OPTION="XBRAID=${XBRAID}"
endif

ifdef P4EST
	P4EST_OPTION="P4EST=${P4EST}"
endif

ifdef DYN_XBRAID
	DYN_XBRAID_OPTION="DYN_XBRAID=${DYN_XBRAID}"
endif

ifdef DYN_P4EST
	DYN_P4EST_OPTION="DYN_P4EST=${DYN_P4EST}"
endif

ifdef DYN_PETSC
	DYN_PETSC_OPTION="DYN_PETSC=${DYN_PETSC}"
endif

ifdef LIBPFASST
	LIBPFASST_OPTION="LIBPFASST=${LIBPFASST}"
endif

ifdef TIMESTAMPS
	TIMESTAMPS_OPTION="TIMESTAMPS=${TIMESTAMPS}"
endif

ifdef DATA_REDIST
	DATA_REDIST_OPTION="DATA_REDIST=${DATA_REDIST}"
endif

.PHONY: applications

all: applications
	

applications:
	cd applications && make INSTALL_DIR=${INSTALL_DIR} DEBUG=${DEBUG} \
	 ${XBRAID_OPTION} ${DYN_XBRAID_OPTION} ${TIMESTAMPS_OPTION} \
	 ${DMR_OPTION} ${P4EST_OPTION} ${DYN_P4EST_OPTION} ${DYN_PETSC_OPTION} \
	 ${MKL_OPTION} ${MPI_OPTION}